jQuery(document).ready(function($){
	var $window=$(window);
	var url=location.href;
	var path=url.split('/');
	var pagename=path[(path.length-1)].split('.html')[0];
	var hashcode=(location.hash!='')?decodeURIComponent(url.split('#')[1]):'';
	var $header=$('.header');
	var $searchcode=$('#searchcode');
	var $btn_search=$('.btn_search');
	var $pagenav=$('#pagenav');
	var $pagenavoption=$pagenav.find('option');
	var $cdtb=$("#codetable");
	var $cdth=$cdtb.find('th');
	var $cdthead=$cdth.find('div');
	var dataIndx=[];
	var thdi={};
	var divdi={};
	var sep='-';
	var tbhflg=false;

	function ckUrl(str){
		var ckflg=false;
		$pagenavoption.each(function(i){if($(this).val()==str){ckflg=true;return ckflg;}});
		return ckflg;
	}

	function ckCode(str,sep){
		var ckstr=[];
		str=str.replace('\\','').replace(/[０-９ｘＸ]/g,function(s){return String.fromCharCode(s.charCodeAt(0)-65248);}).replace('－',sep).replace('−',sep).replace('ー',sep).replace('−',sep).replace('ー',sep).replace('―',sep).replace('‐',sep).replace('-',sep);
		if(str.indexOf(sep)!=-1){
			ckstr=str.split(sep);
			ckstr[0]=ckstr[0].substr(0,4).replace(/X/g,'x').replace(/[^\dx]/g,'');
			ckstr[1]=ckstr[1].substr(0,4);
		}else{
			ckstr[0]=str.slice(0,-4).substr(0,4);
			ckstr[1]=str.slice(-4);
		}
		str=ckstr[0]+sep+ckstr[1];
		if(sep.length>0&&str.length>3){str=str.replace(/^(\d[\dx]{2,3})/g,"$1");}
		return str;
	}

	function setCodeTbThead(){
		if(tbhflg){return false;}
		for(var len=dataIndx.length,ii=len,i,di,w,h;ii--;){
			i=len-ii-1;
			di=dataIndx[i];
			w=~~(thdi[di].width());
			h=~~(divdi[di].height());
			divdi[di].css({'width':w});
			thdi[di].css({'height':h});
		}
		tbhflg=true;
	}
	function resetCodeTableHead(){
		var wintop=~~($window.scrollTop());
		var cdthtop=~~($cdtb.position().top)-(~~($header.height())+12);
		setCodeTbThead();
		if(cdthtop<=wintop){$cdthead.css({'top':wintop-cdthtop});}else{$cdthead.css({'top':0});}
	}

	function setTop(){
		var scrtop=~~($window.scrollTop())-(~~($header.outerHeight())+~~($cdthead.outerHeight()));
		$window.scrollTop(scrtop).scrollLeft(0);
	}

	function doCodeSearch(){
		var val=ckCode($searchcode.val(),sep);
		var fcode=val.split(sep);
		var clscode=(fcode[0])?fcode[0]:pagename;
		var errcode=(fcode[1])?fcode[1]:'0000';
		var hash=(clscode!=='index')?'#'+clscode+'-'+errcode:'';
		var code=$('#'+clscode+'-'+errcode).parent('td').text();
		$searchcode.val(clscode+'-'+errcode);
		if(ckUrl(clscode+'.html')){location.href=clscode+'.html'+hash;if(code!=''){setTop();}return false;}
		if(code!=''){setTop();}
	}

	function main(){
		$('#headnav').removeClass('none');
		$btn_search.click(function(){doCodeSearch();});
		$searchcode.keyup(function(ev){if(ev.keyCode==13){doCodeSearch();}}).val(hashcode);
		$pagenav.change(function(){location.href=$(this).val();return false;});
		if($cdtb&&$cdtb.text()!==''){
			for(var len=$cdth.length,ii=len,i,di;ii--;){
				i=len-ii-1;
				di=$cdth[i].getAttribute('data-dataIndx');
				dataIndx.push(di);
				thdi[di]=$('th.di_'+di);
				divdi[di]=$('div.di_'+di);
			}
			$cdthead.removeClass('none');
			if(hashcode&&hashcode!==''){doCodeSearch();}else{setTop();}
			$window.scroll(function(){resetCodeTableHead();})
			.resize(function(){resetCodeTableHead();})
			.click(function(){resetCodeTableHead();})
			.keyup(function(){resetCodeTableHead();});
			resetCodeTableHead();
		}else{
			if(hashcode&&hashcode!==''){doCodeSearch();}else{setTop();}
		}
	}
	window.setTimeout(function(){main();},500);
});
